function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useContext, useEffect, useMemo, useRef } from 'react';
import Context from './Context';
import useDispatch from './hooks/useDispatch'; // import { useForceUpdate, useIsomorphicLayoutEffect } from './utils';
// import { createDeepProxy, isDeepChanged } from './helpers/deepProxy';
// const deepState = (opts = {}) => {
//   const forceUpdate = useForceUpdate();
//   const { state, subscribe } = useContext(Context);
//   const affected = new WeakMap();
//   const lastRef = useRef(null);
//
//   useIsomorphicLayoutEffect(() => {
//     lastRef.current = {
//       state,
//       affected,
//       cache: new WeakMap(),
//       assumeChangedIfNotAffected: opts.unstable_forceUpdateForStateChange ? true : opts.unstable_ignoreIntermediateObjectUsage ? false : null,
//     };
//   });
//
//   useEffect(() => {
//     const callback = (nextState) => {
//       const changed = isDeepChanged(
//         lastRef.current.state,
//         nextState,
//         lastRef.current.affected,
//         lastRef.current.cache,
//         lastRef.current.assumeChangedIfNotAffected,
//       );
//       if (changed) {
//         lastRef.current.state = nextState;
//         forceUpdate();
//       }
//     };
//
//     forceUpdate();
//
//     return subscribe(callback);
//   }, [subscribe, forceUpdate]);
//
//   const proxyCache = useRef(new WeakMap());
//
//   return createDeepProxy(state, affected, proxyCache.current);
// };

var connect = function connect(mapStateToProps, mapDispatchToProps) {
  return function (Component) {
    return function (props) {
      var _useContext = useContext(Context),
          state = _useContext.state,
          dispatch = _useContext.dispatch;

      var filteredState = {};
      var filteredDispatch = {};

      if (mapStateToProps) {
        filteredState = mapStateToProps(state || {});
      } else {
        filteredState = state;
      }

      if (mapDispatchToProps) {
        filteredDispatch = mapDispatchToProps(dispatch);
      }

      var _useMemo = useMemo(function () {
        return [filteredState, filteredDispatch];
      }, [filteredState, filteredDispatch]),
          _useMemo2 = _slicedToArray(_useMemo, 2),
          memoState = _useMemo2[0],
          memoDispatch = _useMemo2[1];

      return React.createElement(Component, _extends({}, props, memoState, memoDispatch, {
        dispatch: dispatch
      }));
    };
  };
};

export default connect;