function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { useEffect, useState } from 'react';
import { subscribe, unsubscribe } from '../helpers';
import shallowEqual from '../shallowEqual';
var oldState;
export default function useStore(mapStateToProps, initialState) {
  var _useState = useState(initialState),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  oldState = state;
  useEffect(function () {
    subscribe(handleContextChange);
    return function () {
      return unsubscribe(handleContextChange);
    };
  }, []);

  var handleContextChange = function handleContextChange(context) {
    if (typeof mapStateToProps === 'function') {
      var newState = mapStateToProps(context);

      if (!shallowEqual(newState, oldState)) {
        setState(newState);
      }
    } else {
      setState(context);
    }
  };

  return state;
}